import { NextFunction } from "express";
import { IIdentity } from "../global/interface";
import { Request, Response } from "../global/types/express";
export interface IAccessApi {
    method: string;
    path: string;
}
export declare const isAccessApi: (indentity: IIdentity, api: IAccessApi) => Promise<boolean>;
export type ICallback = (req: Request, res: Response, next: NextFunction) => Promise<boolean>;
export declare const middlewareAuth: (req: Request, res: Response, next: NextFunction, api: IAccessApi) => Promise<void>;
export declare const middlewareAccessApi: (req: Request, res: Response, next: NextFunction, api: IAccessApi) => Promise<void>;
export declare const middlewareCallback: (req: Request, res: Response, next: NextFunction, callback: ICallback) => Promise<void>;
export * from "./RoleAndPermissions/role.model";
export * from "./RoleAndPermissions/permission.model";
export * from "./RoleAndPermissions/roleHasPermission.model";
