import { Constructor } from "../decorators/interfaces/constructor";
import { Injector } from "./injector";
import { Config } from "../configs/config";
export declare enum InjectionMode {
    TRANSIENT = "transient",
    SINGLETON = "singleton"
}
interface InjectableInfo<T> {
    constructorFn: Constructor<T>;
    mode: InjectionMode;
    dependencies?: Constructor<any>[];
    singletonInstance?: T;
    alias?: any;
}
export declare class ServiceProvider {
    static app: InjectableInfo<any>[];
    static injectableRegistry: Injector;
    static register<T>(constructorFn: Constructor<T>, mode?: InjectionMode, alias?: any): ServiceProvider;
    static getInfo<T>(constructorFn: Constructor<T>): InjectableInfo<T>;
    static getInstance<T>(constructorFn: Constructor<T> | (abstract new (...args: any[]) => T)): T;
    static setInstance<T>(constructorFn: Constructor<T> | (abstract new (...args: any[]) => T), instance: T): void;
    static config(config: Config): void;
}
export {};
