"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorBuilder = void 0;
const constant_1 = require("./constant");
class ErrorBuilder extends Error {
    constructor(nameError, message, statuCode = 500) {
        super(message);
        this.name = nameError;
        this.message = message;
        this.statusCode = statuCode;
    }
    static error(nameError, message, statuCode = 500) {
        return new ErrorBuilder(nameError, message, statuCode);
    }
    static notFound(message) {
        return this.error(constant_1.Errors.NOT_FOUND, message, 404);
    }
    static validator(message) {
        return this.error(constant_1.Errors.VALIDATOR, message, 400);
    }
    static accessDenied(message = "Access denied") {
        return this.error(constant_1.Errors.ACCESS_DENIED, message, 403);
    }
    static unauthorized(message = "Token is invalid") {
        return this.error(constant_1.Errors.UNAUTHORIZED, message, 401);
    }
}
exports.ErrorBuilder = ErrorBuilder;
