export declare class ResponseBuilder<T> {
    readonly jsonValue: T;
    constructor(jsonValue: T);
    static json<T>(jsonValue: T): ResponseBuilder<T>;
    get(): {
        status: boolean;
        data: T;
    };
    static paginate<T extends {
        data: T["data"];
        totalCount: number;
    }>(jsonValue: T): {
        status: boolean;
        total: number;
        data: T["data"];
    };
    static(): T;
}
